/*
  This software is copyright Kong Inc. and its licensors.
  Use of the software is subject to the agreement between your organization
  and Kong Inc. If there is no such agreement, use is governed by and
  subject to the terms of the Kong Master Software License Agreement found
  at https://konghq.com/enterprisesoftwarelicense/.
*/


import{_ as x,K as b,y as h,F as C,z as P,L as B,U as v,at as H,G as N,u as U,a0 as V,c as f,a as d,b as s,w as i,r,o as c,f as p,h as m,J as Q,d as u,t as I}from"./index.16a2dd6f.js";import{g as K}from"./typedefs.c23224fe.js";import{B as O}from"./Breadcrumbs.a7ee17e6.js";import{P as q}from"./PageHeader.e41a86a8.js";import{E as F}from"./EntityList.646fb83a.js";import{D as j,T as z}from"./TagsBlock.c11d2c63.js";import{D as G}from"./DetailContainer.02ff819a.js";import{E as J}from"./EntityDeleteModal.9f6a6a3a.js";import{E as W}from"./EntityConfiguration.53f2fc95.js";import{S as X}from"./SupportText.472d5280.js";import{s as Y}from"./Target.5dbc1a75.js";import{c as Z}from"./Upstream.c54cae28.js";import{R as $}from"./RbacPermMixin.cfc20df3.js";import{E as ee}from"./EntityMixin.5e010b0c.js";import{R as te}from"./RedirectMixin.43c88d07.js";import"./preferences.b58cae53.js";import"./EntityListEmptyState.405efe97.js";import"./icon-empty-table.dd9dfcd0.js";import"./EntityToggleBadge.51a9520f.js";import"./ConfirmModalDialog.d6b56d6d.js";import"./VerticalTabs.c6fa3050.js";import"./icon-help.300e43ef.js";import"./transform.2ef334b4.js";import"./marked.esm.54f47f7d.js";import"./EntityButton.2576e56c.js";import"./EntityFilter.e9f551d7.js";const re={name:"UpstreamView",components:{PageHeader:q,Breadcrumbs:O,EntityList:F,DetailsHeader:j,DetailContainer:G,TagsBlock:z,EntityDeleteModal:J,SupportText:X,ExternalLink:b,EntityConfiguration:W},mixins:[ee,te,$],props:{entity:{type:Object,default:()=>({id:void 0,name:"Upstream",path:"upstream",rootPath:"upstreams",createRouteName:null})},createTargetPathName:{type:String,default:"create-target"}},data(){return{configSchema:Z,record:{name:""},deleteModalModel:null,redirectRouteAfterDelete:{name:"upstreams"},navItems:[{key:"show-upstream",label:"Configuration"},{key:"upstream-targets",label:"Targets"}]}},computed:{...h(C,["workspace"]),...h(P,{perms:"permissions"}),...h(B,{getSupportDocs:"entityDoc"}),resourceEndpoint(){return this.entity.rootPath},docsLink(){return this.getSupportDocs("target")},id(){return this.record&&this.record.id||this.$route.params.id},targetListOptions(){return{entity:`upstreams/${this.id}/targets`,entityName:"Target",helpMessage:"A target is an ip address/hostname with a port that identifies an instance of a backend service.",createRoute:this.$router.resolve({name:this.createTargetPathName,params:this.$route.params}).path,fields:K(Y),createRouteQuery:{...this.entity,...this.createRedirectRouteQuery()}}},isLoading(){return!this.record},title(){return this.isLoading?"Loading...":this.record.name},titleMapping(){let e=v(this.record,"upstreams")||this.id;return H(e)&&(e=e.split("-")[0].trim()),{id:e}},entityId(){return this.id+","+(this.record&&this.record.name||"")},entityQuery(){return{entity_id:this.entityId,entity_type:"upstream_id"}},actions(){return[{name:"Edit configuration",testAction:"action-edit",isAllowed:this.hasUpdatePerm,handler:this.handleEdit},{name:"Delete",divider:this.hasUpdatePerm,testAction:"action-delete",isAllowed:this.hasDeletePerm,dangerous:!0,handler:this.confirmDelete}]},canCreateTargets(){return this.hasPerms(["create"],`${this.resourceEndpoint}/${this.id}/targets`)},createRoute(){return{name:"create-target",params:{id:this.id},query:{...this.entityQuery,...this.createRedirectRouteQuery()}}},editRoute(){return{name:"update-upstream",params:{id:this.id,returnLink:`/upstreams/${this.id}`},query:this.createRedirectRouteQuery()}}},mounted(){return this.fetchRecord()},methods:{...N(U,["notify"]),fetchSchema(){return this.$api.fetchSchema("upstreams")},fetchRecord(){return this.$api.findRecord("upstreams",this.id).then(e=>{this.record=e.data}).catch(V(this.$router,404,"/404",{replace:!0}))},hasAccessToAction(e,o){return this.$rbac.isAllowed(this.perms,[{path:`/upstreams/${this.id}/targets/${e}/${o}`,actions:["update"]}],this.workspace)},makeHealthyAction(e){return this.$api.makeHealthy(this.id,e.id).then(o=>o.status===204?this.notify({message:"Target marked healthy!",type:"success"}):this.notify({message:"An error occurred please try again",type:"danger"})).catch(()=>this.notify({message:"An error occurred please try again",type:"danger"}))},makeUnhealthyAction(e){return this.$api.makeUnHealthy(this.id,e.id).then(o=>o.status===204?this.notify({message:"Target marked unhealthy!",type:"success"}):this.notify({message:"An error occurred please try again",type:"danger"})).catch(()=>this.notify({message:"An error occurred please try again",type:"danger"}))},handleEdit(){this.$router.push({name:this.editRoute.name,params:this.editRoute.params||{id:this.record.id,returnLink:this.$route.fullPath},query:{...this.editRoute.query,...this.createRedirectRouteQuery(),...this.createPostDeleteRouteQuery()}})},confirmDelete(){this.deleteModalModel={record:this.record}}}},ae={class:"upstreams-view"},ie={class:"upstream-details"},se={key:0,class:"flex flex-col gap-2 mt-4"},oe={class:"flex items-center justify-between"},ne={class:"targets-list"},ce=u(" New Target "),de=u(" Mark Healthy "),me=u(" Mark Unhealthy ");function ue(e,o,l,le,a,t){const g=r("Breadcrumbs"),_=r("TagsBlock"),k=r("DetailsHeader"),R=r("EntityConfiguration"),A=r("KButton"),D=r("ExternalLink"),E=r("SupportText"),w=r("PageHeader"),y=r("KDropdownItem"),S=r("EntityList"),L=r("DetailContainer"),M=r("EntityDeleteModal");return c(),f("section",ae,[d("section",ie,[s(g,{"title-mapping":t.titleMapping},null,8,["title-mapping"]),s(k,{title:t.title,record:a.record,entity:{...l.entity,id:t.id},actions:t.actions},{"below-title":i(()=>[a.record?(c(),f("div",se,[d("div",oe,[a.record.tags&&a.record.tags.length?(c(),p(_,{key:0,tags:a.record.tags},null,8,["tags"])):m("",!0)])])):m("",!0)]),_:1},8,["title","record","entity","actions"])]),s(L,{entity:l.entity,items:a.navItems,"entity-name":"upstream"},{"show-upstream":i(()=>[s(R,{record:a.record,"config-schema":a.configSchema,"edit-route":{name:"update-upstream"},entity:"upstreams","entity-name":"upstream","flatten-actions":""},null,8,["record","config-schema"])]),"upstream-targets":i(()=>[d("section",ne,[s(w,{title:"Targets"},Q({default:i(()=>[s(A,{to:t.createRoute,appearance:"primary"},{default:i(()=>[ce]),_:1},8,["to"])]),_:2},[t.docsLink?{name:"below-title",fn:i(()=>[s(E,null,{default:i(()=>[d("p",null,[s(D,{href:t.docsLink},{default:i(()=>[u(" Learn more about "+I(t.targetListOptions.entityName)+"s ",1)]),_:1},8,["href"])])]),_:1})])}:void 0]),1024),s(S,{options:t.targetListOptions,"enable-entity-actions":!0,"overflow-actions":!0,"show-update-action":!1,"disable-row-click":!0},{extraActions:i(n=>[t.hasAccessToAction(n.item.id,"healthy")?(c(),p(y,{key:0,onClick:T=>t.makeHealthyAction(n.item)},{default:i(()=>[de]),_:2},1032,["onClick"])):m("",!0),t.hasAccessToAction(n.item.id,"unhealthy")?(c(),p(y,{key:1,onClick:T=>t.makeUnhealthyAction(n.item)},{default:i(()=>[me]),_:2},1032,["onClick"])):m("",!0)]),_:1},8,["options"])])]),_:1},8,["entity","items"]),s(M,{modelValue:a.deleteModalModel,"onUpdate:modelValue":o[0]||(o[0]=n=>a.deleteModalModel=n),entity:l.entity.rootPath,"redirect-route":a.redirectRouteAfterDelete,"entity-name":"upstream",class:"defaultModal"},null,8,["modelValue","entity","redirect-route"])])}const Qe=x(re,[["render",ue]]);export{Qe as default};
